with GNATCOM.IInterface;

with GNATCOM.Errors;

package body MSHTML.IHTMLBlockElement3_Interface is

   procedure Initialize (This : in out IHTMLBlockElement3_Type) is
   begin
      Set_IID (This, IID_IHTMLBlockElement3);
   end Initialize;

   function Pointer (This : IHTMLBlockElement3_Type)
     return Pointer_To_IHTMLBlockElement3
   is
   begin
      return To_Pointer_To_IHTMLBlockElement3 (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLBlockElement3_Type;
                     Pointer : in     Pointer_To_IHTMLBlockElement3)
   is
   begin
      Attach (This, GNATCOM.IInterface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_cite
     (This : IHTMLBlockElement3_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_cite
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_cite;

   function Get_cite
     (This : IHTMLBlockElement3_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_cite
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_cite;

end MSHTML.IHTMLBlockElement3_Interface;

